<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');
 

class GPIODriverViewPins extends JViewLegacy
{
	protected $items;

	protected $pagination;

	protected $state;

	protected $tmpl;

	function display($tpl = null)
	{
		
    		// Get application
		$app = JFactory::getApplication();
		$context = "gpiodriver.list.admin.pin";
		// Get data from the model
		$this->items			= $this->get('Items');
		$this->pagination		= $this->get('Pagination');
		$this->state			= $this->get('State');
		$this->filter_order 	= $app->getUserStateFromRequest($context.'filter_order', 'filter_order', 'comune', 'cmd');
		$this->filter_order_Dir = $app->getUserStateFromRequest($context.'filter_order_Dir', 'filter_order_Dir', 'asc', 'cmd');
		$this->filterForm    	= $this->get('FilterForm');
		$this->activeFilters 	= $this->get('ActiveFilters');
		
		$this->setDocument();	
		
		$this->addToolbar();
		
		parent::display($tpl);
		
	}
		
			protected function addToolBar()
	{
		$title = JText::_('COM_GPIODRIVE_PANNEL_CONTROL_TITLE');
		
		JToolBarHelper::title( $title , 'GPIO PINs' );
		JToolBarHelper::deleteList('', 'pins.delete');
		//JToolbarHelper::trash('pins.trash');
		JToolBarHelper::editList('pin.edit');
		
		if ($this->pagination->total)
			{
				$title .= "<span style='font-size: 0.5em; vertical-align: middle;'>(" . $this->pagination->total . ")</span>";
			}
	}
	
	protected function setDocument()
 	{		
		$document = JFactory::getDocument();
		$document->setTitle(JText::_('COM_MIDPS_COMUNIBRICKS_PANNEL_CONTROL_TITLE'));
	}

    protected function getSortFields()
	{
		return array(
			'id' =>  JText::_( 'COM_GPIODRIVER_ID_COLUMN_LABEL'),
			'mode' =>  JText::_('COM_GPIODRIVER_MODE_COLUMN_LABEL'),
			'pin' => JText::_('COM_GPIODRIVER_PIN_COLUMN_LABEL'),
			'pull' => JText::_('COM_GPIODRIVER_PULL_COLUMN_LABEL'),
			'title' => JText::_('COM_GPIODRIVER_TITLE_COLUMN_LABEL')
			);
	}
}