<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

// Include dependancy of the main model form
jimport('joomla.filesystem.file');
jimport('joomla.event.dispatcher');
jimport('joomla.application.component.modelform');


class GPIODriverModelgpiodriver extends JModelForm
{

  public function getForm($data = array(), $loadData = true) 
  {
    // Get the form.
    $form = $this->loadForm('com_gpiodriver.gpiodriver', 'gpiodriver', array('control' => 'jform', 'load_data' => $loadData));
    return $form;
  }


	function getBD_GPIO_State()
    {

		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
	
		$query
			->select('*')
    		->from('#__gpiodriver_setup');
	
		$db->setQuery($query);
	
		$GPIO_State = $db->loadObjectList();
		
	  	return  $GPIO_State;
  	 
    }
    
    
    function getHW_GPIO_State()
    {

		$gpio_pin = $this->getBD_GPIO_State();
	
		foreach($gpio_pin as $pin)
		{
		 exec ("gpio read " .$pin->pin , $GPIO_State );
		}
		
		return $GPIO_State;
		
    }
    
    
    function setGPIO_State($gpio_state)
    {
    
		
		
		$pin = explode(":",$gpio_state);
		
		if ($pin[2] == "out"){
		
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);
	
		$query
		->update('#__gpiodriver_setup')
		->where('pin = "' . (int) $pin[0].'"');
	
		if ($pin[1] == "down"){
			$query->set(' pull = '.$db->Quote('up'));
			$mode= 'up';	
		}elseif($pin[1] == "up") {
			$query->set(' pull = '.$db->Quote('down'));
			$mode= 'down';
		}
	
		$db->setQuery((string)$query);	

		if (!$db->query()) {

			JError::raiseError(500, $db->getErrorMsg());

        	return false;

        } else {
        
        	exec( "gpio mode ".$pin[0]." ".$mode."");
        	return true;

		}
		
		}
  	 
    }
    
	
	public function getGPIO()
	{
	
		$data = JRequest::get();
	

		if( isset($data["GPIO"]) AND $data["GPIO"] != "")
		{
			$this->setGPIO_State($data["GPIO"]);
		}	
	
		$gpio_pin_hw = $this->getHW_GPIO_State();
		
		$gpio_pin_db = $this->getBD_GPIO_State();
		

		foreach($gpio_pin_db as $pin){ 
	
			if ($pin->mode == "in")
			{
		
				if ($gpio_pin_hw[$pin->pin])
				{
		
					$gpio_mode_array[$pin->pin]['pull'] = "up";
			
				}else{
			
					$gpio_mode_array[$pin->pin]['pull'] = "down";
			
				}
		
			}else{
			
				$gpio_mode_array[$pin->pin]['pull'] = $pin->pull;
			
			}
		
		$gpio_mode_array[$pin->pin]['id'] = $pin->id;
		$gpio_mode_array[$pin->pin]['pin'] = $pin->pin;
		$gpio_mode_array[$pin->pin]['mode'] = $pin->mode;
		$gpio_mode_array[$pin->pin]['titolo'] = $pin->title;
		
		}
	
		return $gpio_mode_array;


	}


}



