<?php
// No direct access to this file
defined('_JEXEC') or die; 

class GPIODriverModelPin extends JModelAdmin
{
	
	public function getTable($type = 'Pins', $prefix = 'GPIODriverTable', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}
	
	public function getForm($data = array(), $loadData = true) 
	{
    // Get the form.
    $form = $this->loadForm(
		'com_gpiodriver.pin',
		'pin',
		array(
			'control' => 'jform',
			'load_data' => $loadData
			)
		);
  
	if (empty($form))
		{
			return false;
		}

		return $form;
	}
 
	protected function loadFormData() 
	{
    // Check the session for previously entered form data.
    $data = JFactory::getApplication()->getUserState(
		'com_gpiodriver.edit.pin.data',
		array()
	);
    
	if(empty($data))
	{
    	$data = $this->getItem();
    }
    
	return $data;
  
  }
 
}
