<?php
defined('_JEXEC') or die();
  
class GPIODriverModelPins extends JModelList
{
	public function __construct($config = array())
	{
		if (empty($config['filter_fields']))
			{
				$config['filter_fields'] = array(
				'id',
				'pin',
				'pull',
				'mode',
				'title'
				);
		}
	
		parent::__construct($config);
		
	}

	
    function getListQuery()
    {
    $db = $this->getDbo();
	$query = $db->getQuery(true);
	$user = JFactory::getUser();
	$app = JFactory::getApplication();
	
	
	$query->select('t_pins.*')
		->from('#__gpiodriver_setup AS t_pins');
	
	// Filter by search
	$search = $this->getState('filter.search');
       if (!empty($search))
	   {
           $search = $db->Quote('%'.$db->escape($search, true).'%');
           $query->where('((t_pins.id LIKE '.$search.')
						OR (t_pins.pin LIKE '.$search.'))');
        }
    	
	// Add the list ordering clause.
		$orderCol = $this->state->get('list.ordering', 't_pins.id');
		$orderDirn = $this->state->get('list.direction', 'asc');


		$query->order($db->escape($orderCol . ' ' . $orderDirn));
		
		
	   
   return  $query;

   }
   
    function GPIO_SET(){
	
	$db = JFactory::getDBO();
	$query = $db->getQuery(true);
	
	$query
	->select('*')
    ->from('#__gpiodriver_setup')
	;
	
	$db->setQuery($query);

	$GPIO_Setup = $db->loadObjectList();
		
	
	foreach ($GPIO_Setup as $pin) {
    system ( "gpio mode ".$pin->pin." ".$pin->mode." " );
    sleep(0.1);
    system ( "gpio mode ".$pin->pin." ".$pin->pull." " );
    sleep(0.1);
    
	}

	
	}

    

    protected function populateState($ordering = null, $direction = null)
    {
	
		$this->GPIO_SET();
		
      $search = $this->getUserStateFromRequest($this->context . '.filter.search', 'filter_search');
		$this->setState('filter.search', $search);
	
		$state = $this->getUserStateFromRequest($this->context . '.filter.state', 'filter_state');
		$this->setState('filter.state', $state);
		
		// List state information.
        parent::populateState($ordering, $direction);
        
    }
}
