<?php
// No direct access to this file
defined('_JEXEC') or die; 


class GPIODriverViewPin extends JViewLegacy
{

protected $form;
protected $item;
protected $state;
protected $tmpl;

  public function display($tpl = null) 
  {
    

		$this->form		= $this->get('Form');
		$this->item		= $this->get('Item');
		$this->state	= $this->get('State');
 
   // Check for errors.
		if (count($errors = $this->get('Errors')))
		{
			JError::raiseError(500, implode('<br />', $errors));

			return false;
		}

		// Set the toolbar
		$this->addToolBar();

		// Display the template
		parent::display($tpl);

		// Set the document
		$this->setDocument();
	}
 
  protected function addToolBar() 
  {
	
			$input = JFactory::getApplication()->input;

		// Hide Joomla Administrator Main menu
		$input->set('hidemainmenu', true);

		$isNew = ($this->item->id == 0);

    		JToolBarHelper::title(JText::_('COM_GPIODRIVE_PANNEL_CONTROL_TITLE'));
	
			if ($isNew)
		{
			// For new records, check the create permission.
			
			
				JToolBarHelper::apply('pin.apply', 'JTOOLBAR_APPLY');
				JToolBarHelper::save('pin.save', 'JTOOLBAR_SAVE');
				JToolBarHelper::custom('pin.save2new', 'save-new.png', 'save-new_f2.png',
				                       'JTOOLBAR_SAVE_AND_NEW', false);
			
			JToolBarHelper::cancel('pin.cancel', 'JTOOLBAR_CANCEL');
		}
		else
		{
			
			
		
				// We can save the new record
				JToolBarHelper::apply('pin.apply', 'JTOOLBAR_APPLY');
				JToolBarHelper::save('pin.save', 'JTOOLBAR_SAVE');
 
				// We can save this record, but check the create permission to see
				// if we can return to make a new one.
				
					JToolBarHelper::custom('pin.save2new', 'save-new.png', 'save-new_f2.png',
					                       'JTOOLBAR_SAVE_AND_NEW', false);
				
			
			
				JToolBarHelper::custom('pin.save2copy', 'save-copy.png', 'save-copy_f2.png',
				                       'JTOOLBAR_SAVE_AS_COPY', false);
			
			JToolBarHelper::cancel('pin.cancel', 'JTOOLBAR_CLOSE');
		}
	}
	
	protected function setDocument() 
	{
		$isNew = ($this->item->id == 0);
		$document = JFactory::getDocument();
		$document->setTitle(JText::_('COM_GPIODRIVE_PANNEL_CONTROL_TITLE'));
		JText::script('COM_GPIODRIVER_ERROR_UNACCEPTABLE');
	}
	
}
