<?php

defined('_JEXEC') or die('Restricted Access');

JHtml::_('formbehavior.chosen', 'select');
$listOrder     = $this->escape($this->state->get('list.ordering'));
$listDirn      = $this->escape($this->state->get('list.direction'));
$sortFields 	= $this->getSortFields();
$saveOrder = $listOrder == 'ordering';

if ($saveOrder)
{
	$saveOrderingUrl = 'index.php?option=com_contact&task=contacts.saveOrderAjax&tmpl=component';
	JHtml::_('sortablelist.sortable', 'contactList', 'adminForm', strtolower($listDirn), $saveOrderingUrl);
}

JFactory::getDocument()->addScriptDeclaration('
	Joomla.orderTable = function()
	{
		table = document.getElementById("sortTable");
		direction = document.getElementById("directionTable");
		order = table.options[table.selectedIndex].value;
		if (order != "' . $listOrder . '")
		{
			dirn = "asc";
		}
		else
		{
			dirn = direction.options[direction.selectedIndex].value;
		}
		Joomla.tableOrdering(order, dirn, "");
	};
');

?>


<form action="<?php echo JRoute::_('index.php?option=com_gpiodriver&view=pins'); ?>" method="post" name="adminForm" id="adminForm">
		
		<div id="filter-bar" class="btn-toolbar">
			<div class="filter-search btn-group pull-left">
				<label for="filter_search" class="element-invisible"><?php echo JText::_('JSEARCH_FILTER');?></label>
				<input type="text" name="filter_search" id="filter_search" placeholder="<?php echo JText::_('JSEARCH_FILTER'); ?>" value="<?php echo $this->escape($this->state->get('filter.search')); ?>" class="hasTooltip" title="<?php echo JHtml::tooltipText('JSEARCH_FILTER'); ?>" />
			</div>
			<div class="btn-group pull-left">
				<button type="submit" class="btn hasTooltip" title="<?php echo JHtml::tooltipText('JSEARCH_FILTER_SUBMIT'); ?>"><i class="icon-search"></i></button>
				<button type="button" class="btn hasTooltip" title="<?php echo JHtml::tooltipText('JSEARCH_FILTER_CLEAR'); ?>" onclick="document.getElementById('filter_search').value='';this.form.submit();"><i class="icon-remove"></i></button>
			</div>
			<div class="btn-group pull-right hidden-phone">
				<label for="limit" class="element-invisible"><?php echo JText::_('JFIELD_PLG_SEARCH_SEARCHLIMIT_DESC');?></label>
				<?php echo $this->pagination->getLimitBox(); ?>
			</div>
			<div class="btn-group pull-right hidden-phone">
				<label for="directionTable" class="element-invisible"><?php echo JText::_('JFIELD_ORDERING_DESC');?></label>
				<select name="directionTable" id="directionTable" class="input-medium" onchange="Joomla.orderTable()">
					<option value=""><?php echo JText::_('JFIELD_ORDERING_DESC');?></option>
					<option value="asc" <?php if ($listDirn == 'asc') echo 'selected="selected"'; ?>><?php echo JText::_('JGLOBAL_ORDER_ASCENDING');?></option>
					<option value="desc" <?php if ($listDirn == 'desc') echo 'selected="selected"'; ?>><?php echo JText::_('JGLOBAL_ORDER_DESCENDING');?></option>
				</select>
			</div>
			<div class="btn-group pull-right">
				<label for="sortTable" class="element-invisible"><?php echo JText::_('JGLOBAL_SORT_BY');?></label>
				<select name="sortTable" id="sortTable" class="input-medium" onchange="Joomla.orderTable()">
					<option value=""><?php echo JText::_('JGLOBAL_SORT_BY');?></option>
					<?php echo JHtml::_('select.options', $sortFields, 'value', 'text', $listOrder);?>
				</select>
			</div>
		</div>
		
			
		
		<div class="clearfix"> </div>
		<?php if (empty($this->items)) : ?>
			<div class="alert alert-no-items">
				<?php echo JText::_('JGLOBAL_NO_MATCHING_RESULTS'); ?>
			</div>
		<?php else : ?>

		<table class="table table-striped">
				<thead>
				<tr>
					<th class="center" width="3%">
						<?=JHtml::_('grid.sort',  JText::_( 'COM_GPIODRIVE_ID_COLUMN_LABEL'), 'id', $listDirn, $listOrder); ?>
					</th>
					<th class="center" width="3%">
						<input type="checkbox" onclick="Joomla.checkAll(this)" title="<?=JText::_( 'JGLOBAL_CHECK_ALL' )?>" value="" name="checkall-toggle">
					</th>
					<th class="center" width="35%"><?php echo JText::_('COM_GPIODRIVE_MODE_COLUMN_LABEL'); ?>
					</th>
					<th class="center" width="14%">
						<?=JHtml::_('grid.sort', 'COM_GPIODRIVE_PIN_COLUMN_LABEL', 'pin', $listDirn, $listOrder); ?>
					</th>
					<th class="center" width="15%">
						<?=JHtml::_('grid.sort', 'COM_GPIODRIVE_PULL_COLUMN_LABEL', 'pull', $listDirn, $listOrder); ?>
					</th >
					<th class="center" width="15%">
						<?=JHtml::_('grid.sort', 'COM_GPIODRIVE_TITLE_COLUMN_LABEL', 'title', $listDirn, $listOrder); ?>
					</th >
				</tr>
			</thead>

				<tbody>
					<?php //foreach ($this->items as $i => $item) :
						//$canCreate  = $user->authorise('core.create',     'com_gpiodriver');
						//$canEdit    = $user->authorise('core.edit',       'com_gpiodriver');
						//$canCheckin = $user->authorise('core.manage',     'com_gpiodriver') || $item->checked_out == $user->get('id') || $item->checked_out == 0;
						//$canChange  = $user->authorise('core.edit.state', 'com_gpiodriver') && $canCheckin;
						?>
						<tbody>
<?php  foreach($this->items as $i => $item): ?>
  <tr class="row<?php echo $i % 2; ?>">
  <td class="center"><?php echo $item->id; ?></td>
  <td class="center"><?php echo JHtml::_('grid.id', $i, $item->id); ?></td>
  <td >
  <a href="<?php echo JRoute::_('index.php?option=com_gpiodriver&task=pin.edit&id=' . $item->id); ?>">
  <?php echo $item->mode; ?>
  </a>
  </td>
  <td >
  <a href="<?php echo JRoute::_('index.php?option=com_gpiodriver&task=pin.edit&id=' . $item->id); ?>">
  <?php echo $item->pin; ?>
  </a>
  </td>
   <td>
  <a href="<?php echo JRoute::_('index.php?option=com_gpiodriver&task=pin.edit&id=' . $item->id); ?>">
  <?php echo $item->pull; ?>
  </a>
  </td>
  <td>
  <a href="<?php echo JRoute::_('index.php?option=com_gpiodriver&task=pin.edit&id=' . $item->id); ?>">
  <?php echo $item->title; ?>
  </a>
  </td>
  </tr>
<?php endforeach; ?>

</tbody>
				<tfoot>
					<tr>
						<td colspan="9">
							<?php echo $this->pagination->getListFooter(); ?>
						</td>
					</tr>
				</tfoot>
		</table>
<?php endif; ?>

		<input type="hidden" name="task" value="" />
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $listOrder; ?>"/>
		<input type="hidden" name="filter_order_Dir" value="<?php echo $listDirn; ?>"/>
		<?php echo JHtml::_('form.token'); ?>
	</div>
</form>
