<?php
defined('_JEXEC') or die;

require_once ('components/com_bricks/helpers' .DIRECTORY_SEPARATOR. 'helper.php');

function TIPOASSENZE($id_richiesta)
    {
	
	$db = JFactory::getDBO();
	$query = $db->getQuery(true);
	
	$query->clear();
	$query
	->select('*')
    ->from('#__bricks_spot_assenze ')
	->where('id_richiesta =' . $id_richiesta);
	$db->setQuery($query);
	$spot = $db->loadAssocList();
	
	$i=0;
	if (count($spot)>0)
	{
		foreach ($spot as $row) 
		{
			$id_cat_spot[$i] = $row['id_cat'];
			$i++;
		}
	}
	
	$query->clear();
	$query
	->select('*')
    ->from('#__bricks_categorie_assenze');
	//->where('t_assenze.id =' . $id);
	$db->setQuery($query);
	$categorie = $db->loadAssocList();
	
	$i=0;
	if (count($categorie)>0)
	{
		foreach ($categorie as $row) 
		{
			if (in_array($row['id'], $id_cat_spot))
			{
				$tipi_assenze[$i] =  $row['abb_denominazione'];
			}
		$i++;
		}
	}
	
	$result = implode (' - ',$tipi_assenze);
	
	return $result;
	
	}
	
	function Parere( $id_richiesta )
    {
	
	$db = JFactory::getDBO();
	$query = $db->getQuery(true);
	$query->clear();
	////////////// elenco richieste con parere favorevole /////////////////
	//////////////////////////////////////////////////////////////////////
	   
	$query->select('t_assenze.id ' );
	
	
	$query->from('#__bricks_assenze  AS t_assenze '  );
	$query->where('t_assenze.id IN
					(SELECT t_eventi_assenze.id_richiesta FROM #__bricks_eventi_assenze AS t_eventi_assenze  WHERE 
					(t_eventi_assenze.tipo_vidima LIKE "parere favorevole") )'); 
	 

		$db->setQuery($query);
	
		$elenco =	 $db->loadAssocList();
		
		$elenco_pareri["favorevoli"] =	 $elenco;
		
	////////////// elenco richieste con parere negativo /////////////////
	//////////////////////////////////////////////////////////////////////
	$query->clear();
	$query->select('t_assenze.id ' );
	
	
	$query->from('#__bricks_assenze  AS t_assenze '  );
	$query->where('t_assenze.id IN
					(SELECT t_eventi_assenze.id_richiesta FROM #__bricks_eventi_assenze AS t_eventi_assenze  WHERE 
					(t_eventi_assenze.tipo_vidima LIKE  "parere negativo") )'); 
	 

		$db->setQuery($query);
	
		$elenco =	 $db->loadAssocList();
		
		$elenco_pareri["negativi"] =	 $elenco;
		
		$parere = "";

	
		foreach ($elenco_pareri["favorevoli"] as $row) 
		{
			if ($row["id"] == $id_richiesta)
			{
				$parere = "parere_f";
			}
		}
		
		foreach ($elenco_pareri["negativi"] as $row) 
		{
			if ($row["id"] == $id_richiesta)
			{
				$parere = "parere_n";
			}
		}
	
		
	return $parere;
     
	}
	
	function in_programmazione($id_richiesta)
    {
	
	
	$result = false;
	
    $db = JFactory::getDBO();
	
	$query = $db->getQuery(true);
	
	$query->clear();
	
	$query->select(array('t_assenze.*' , 't_profili.cognome_nome' , 't_qualifiche.qualifica_ab'));

    $query->from('#__bricks_assenze as t_assenze');
	
	$query->join('INNER', '#__bricks_profili AS t_profili ON (t_assenze.per_id = t_profili.per_id)');
	
	$query->join('INNER', '#__bricks_qualifiche AS t_qualifiche ON (t_profili.qualifica = t_qualifiche.id)');
	
	$query->where('t_assenze.id=' .$db->Quote($id_richiesta));
	
		// Filter by search

    $db->setQuery($query);

	$richiesta = $db->loadAssoc();
		
	
	$query = $db->getQuery(true);

	$query->clear();
	
	$query->select('t_programmazione.*');

    $query->from('#__bricks_programmazione_assenze AS t_programmazione');
		
	$db->setQuery($query);
	
	$programmazione = $db->loadAssocList();
	
	foreach ($programmazione as $row) 
		{
			if (($row['data_inizio_periodo'] <= $richiesta['data_inizio'] AND $row['data_fine_periodo'] >= $richiesta['data_inizio'] )
				OR
				($row['data_inizio_periodo'] <= $richiesta['data_fine'] AND $row['data_fine_periodo'] >= $richiesta['data_fine'] ))
			{
			$result = true;
			}
		}
	
	return $result;
	
	}


